/* 
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

import QtQuick
import QtQuick.Window
import Mirai

Item {
	property QtObject selected: OneDark

	function applyCustomThemeFromConfig() {
		//console.log(backend.getThemeColor("text"))
		console.log(Object.keys(selected))
		selected.background = getThemeColor("background")
		selected.pane = getThemeColor("pane")
		selected.text = getThemeColor("text")
		selected.textPlaceholder = getThemeColor("textPlaceholder")
		selected.accent = getThemeColor("accent")
		selected.fieldBackground = getThemeColor("fieldBackground")
		selected.buttonIcon = getThemeColor("buttonIcon")
		selected.buttonBackground = getThemeColor("buttonBackground")
		selected.buttonHovered = getThemeColor("buttonHovered")
		selected.filterHovered = getThemeColor("filterHovered")
		selected.filterSelected = getThemeColor("filterSelected")
		selected.modalBorder = getThemeColor("modalBorder")
		selected.calendarLines = getThemeColor("calendarLines")
		selected.calendarCurrentTime = getThemeColor("calendarCurrentTime")
		selected.calendarEvent = getThemeColor("calendarEvent")
		selected.green = getThemeColor("green")
		selected.red = getThemeColor("red")
	}

	// Proxy function for backend.getThemeColor that do not override the value if
	// no custom color are defined for this element
	function getThemeColor(element) {
		let elementColor = backend.getThemeColor(element)
		if (!elementColor) {
			return selected[element];
		}
		return elementColor;
	}

	Component.onCompleted: {
		applyCustomThemeFromConfig()
	}
}
